function hookFunction(orig,newfunc,after)
  if(not hookFunction_orig) then
    hookFunction_orig = {};
  end
  if(hookFunction_orig[orig]) then
    dbanner("Tried to hook function already hooked: ",orig);
    return;
  end
  hookFunction_orig[orig] = getglobal(orig);
  local origfunc = getglobal(orig);
  if(after) then
    setglobal(orig,function(...) local ret = origfunc(...);newfunc(...);return ret; end);
  else
    setglobal(orig,function(...) newfunc(...);return origfunc(...); end);
  end
end
function unHookFunction(orig)
  if(hookFunction_orig[orig]) then
    setglobal(orig,hookFunction_orig[orig]);
    hookFunction_orig[orig] = nil;
  else
    dbanner("Tried to unhook function that isn't hooked: ",orig);
  end
end
function dbanner(...)
  if(Thottbot.Debug) then
    UIErrorsFrame:AddMessage(joinx("",...), 0.9, 0.9, 0.0, 1.0, UIERRORS_HOLD_TIME);			  					
    dprint(joinx("",...));
  end
end
function banner(...)
  UIErrorsFrame:AddMessage(joinx("",...), 0.9, 0.9, 0.0, 1.0, UIERRORS_HOLD_TIME);			  					
end
function round(x)
  if(x - math.floor(x) > 0.5) then
    x = x + 0.5;
  end
  return math.floor(x);
end
function dbyte(c)
  return string.format("<%02X>",string.byte(c));
end
function dprint_runqueue()
  local counter = 10;
  while(counter > 0) do
    counter = counter - 1;
    print2(dprint_queue[dprint_queue_i]);
    dprint_queue_i = dprint_queue_i+1;
    if(dprint_queue_i > #dprint_queue) then
      dprint_queue = nil;
      return true;
    end
  end
end
function Tescape(msg)
  msg = string.gsub(msg,"|","<pipe>");
  msg = string.gsub(msg,"([^%w%s%a%p])",dbyte);
  return msg;
end
function dprint(...)
  if(Thottbot.Debug) then
    local msg = joinx("",...);
    msg = Tescape(msg);
--    if(Thottbot.DebugFrame) then
--      printframe(Thottbot.DebugFrame,msg);
--    else
--      print2(msg);
--    end
    if(not dprint_queue) then
      dprint_queue = {};
      dprint_queue_i = 1;
      --Chronos.everyFrame(dprint_runqueue);
    end
    push(dprint_queue,msg);
  end
end
function dprinttable(t,indent)
  if(Thottbot.Debug) then
    if(not indent) then
      indent = " ";
    end
    if(type(v) == "table") then
      for k,v in pairs(t) do
	if(type(v) == "table") then
	  dprint(indent,k," =>");
	  dprinttable(v,indent.."  ");
	else
	  dprint(indent,k," => ",v);
	end
      end
    else
      dprint("not a table: ",t);
    end
  end
end
function dprint1(...)
  if(Thottbot.Debug) then
    print1(joinx("",...));
  end
end
function split(s,seperator)
  local t = {};
  for value in string.gmatch(s,"[^"..seperator.."]+") do
    push(t,value);
  end
  return t;
end
function joinl(list,seperator)
  local msg = "";
  local c = "";
  for i=1, #list do
    local arg = list[i];
    if(arg) then
      if(type(arg) == "table") then
        msg = msg .. c .. joinl(arg,seperator);
      else
	msg = msg .. c .. arg;
      end
    else
      msg = msg .. c .. "(nil)";
    end
    c = seperator;
  end
  return msg;
end
function join(...)	-- arg,arg,arg,...,seperator
  local args = select("#",...);
  local seperator = select(args,...);
  local i;
  local c = "";
  local msg = "";
  for i=1, args do
    local arg = select(i,...);
    if(i == args) then
      break;
    end
    if(arg) then
      if(type(arg) == "table") then
        msg = msg .. c .. joinl(arg,seperator);
      else
	msg = msg .. c .. arg;
      end
    else
      msg = msg .. c .. "(nil)";
    end
    c = seperator;
  end
  return msg;
end
function joinx(seperator,...)	-- seperator,arg,arg,...
  local c = "";
  local msg = "";
  local i;
  for i=1, select("#",...) do
    local arg = select(i,...);
    if(arg) then
      if(type(arg) == "table") then
        msg = msg .. c .. joinl(arg,seperator);
      elseif(type(arg) == "boolean") then
        if(arg) then
	  msg = msg .. c .. "true";
	else
	  msg = msg .. c .. "false";
	end
      else
	msg = msg .. c .. arg;
      end
    else
      msg = msg .. c .. "(nil)";
    end
    c = seperator;
  end
  return msg;
end
function dprintlist(list)
  if(Thottbot.Debug) then
    if(list) then
      dprint(join(list,","));
    else
      dprint("nil list");
    end
  end
end
function dprintcomma(...)
  dprint(joinx(",",...));
end
function printframe(frame,...)
  if(frame) then
    frame:AddMessage(joinx("",...), 1.0, 1.0, 0.0);
  end
end
function print2(...)
  if(ChatFrame2) then
    ChatFrame2:AddMessage(joinx("",...), 1.0, 1.0, 0.0);
  end
end
function print1e(...)
  local msg = joinx("",...);
  print1(Tescape(msg));
end
function print1(...)
  if(ChatFrame1) then
    ChatFrame1:AddMessage(joinx("",...), 1.0, 1.0, 0.0);
  end
end
function print1comma(...)
  if(ChatFrame1) then
    ChatFrame1:AddMessage(joinx(",",...), 1.0, 1.0, 0.0);
  end
end
function push(t,v)
  --if(not t) then
  --  dbanner("Bad table passed to push");
  --  return nil;
  --end
  t[#t+1] = v;
end
function pop(t)
  --if(not t) then
  --  dbanner("Bad table passed to pop");
  --  return nil;
  --end
  local v = t[#t];
  table.remove(t);
  return v;
  --local v = t[t.n];
  --t.n = t.n - 1;
  --return v;
end
function push2(t,x,y)
  --if(not t) then
  --  dbanner("Bad table passed to push2");
  --  return nil;
  --end
  t[#t+1] = x;
  t[#t+1] = y;
  --t.n = t.n+1;
  --t[t.n] = x;
  --t.n = t.n+1;
  --t[t.n] = y;
end
function pop2(t)
  --if(not t or not t.n) then
  --  --dbanner("Bad table passed to pop2");
  --  return nil;
  --end
  if(#t < 2) then
    return nil;
  end
  local tt = {};
  tt[1] = t[#t-1];
  tt[2] = t[#t];
  table.remove(t);
  table.remove(t);
  return tt;
  --tt.n = 2;
  --tt[1] = t[t.n-1];
  --tt[2] = t[t.n];
  --t.n = t.n - 2;
  --return tt;
end
function fixnil(...)
  local arg = {};
  for i=1, select("#",...), 1 do
    local x = select(i,...);
    if(not x) then
      push(arg,"(nil)");
    else
      push(arg,x);
    end
  end
  return arg;
end
function fixnilempty(...)
  local arg = {};
  for i=1, select("#",...), 1 do
    local x = select(i,...);
    if(not x) then
      push(arg,"");
    else
      push(arg,x);
    end
  end
  return arg;
end
function fixnilzero(...)
  local arg = {};
  for i=1, select("#",...), 1 do
    local x = select(i,...);
    if(not x) then
      push(arg,0);
    else
      push(arg,x);
    end
  end
  return arg;
end
